#!/bin/sh

. /tmp/openit-cfg-shenv

ARCH="big"

#Get the first three part of the version
ver3=`grep VERSION $ROOT_TEMP_DIR/inst/package/accserver.info | cut -d" " -f2 | cut -d "." -f 1-3 | tr -d '.'`
#Get the last part of the version
lastPart=`grep VERSION $ROOT_TEMP_DIR/inst/package/accserver.info | cut -d" " -f2 | cut -d "." -f 4`
#Concatenate the two parts to get the version
version=$ver3$lastPart


#If the first three part is less than 6.2.0, use the index.php for 6.1 and lower
if [ $ver3 -lt 630 ]; then
	version=""
else
	version="63"
fi

#Get the Architecture of the machine
if [ `uname` = "SunOS" ]; then
	ARCH="solaris"
elif [ `uname` = "Linux" ]; then
	if [ `uname -p` = "i686" ]; then
		ARCH="little"
	else
		ARCH="little64"
	fi
fi

#Copy the appropriate MenuDisplayer.php for the Resources Page
cp source/$ARCH/classes/mvc/presentation/MenuDisplayer$version.php $ROOT_DIR/classes/mvc/presentation/MenuDisplayer.php

exit 0

