<?php

// Load the initiation file
require_once($_SERVER["DOCUMENT_ROOT"] . "/../classes/initiation.php");

// Check if we have RealTime data...
if (!RealTime::isRealTimeEnabled()) {
	header("Location: /access.php");
	return;
}

// Clear cache data...
//$_SESSION["REALTIME"] = null;

// Get realtime
//This will store temporarily the RealTime Data into this Session
if(!isset($_SESSION["REALTIME"]["LICENSE_MONITOR"])) {
	$_SESSION["REALTIME"]["LICENSE_MONITOR"] = RealTime::getInstance(false,true);
}
$realTime = &$_SESSION["REALTIME"]["LICENSE_MONITOR"];

// Remove previous RealTime selections
$realTime->clearSelections();

// Remove GUI selections
$selection = new ReportSelection();
$selection->set(RealTime::GUI_VIEWBY, "");
$selection->set(RealTime::GUI_SORTBY, "");
$selection->set(RealTime::GUI_SORTASC, "0");
$selection->set("presentation_type", "chart");
$selection->set(RealTime::GUI_USERBLOCK, array());

// Load presentation layer class
$presentation = new Presentation();

// Send data to presentation
$presentation->assign("realtime", $realTime);

// Show presentation
$presentation->display("pages/dashboard/license/index.php");

?>