<?php
$CSS_for_IE6 = (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 6.') !== FALSE) ? '-IE' : '';
$tz = date_default_timezone_get();
date_default_timezone_set('UTC');
// Get user selections
$selection = new ReportSelection();

// If we have a offset posted, we use this when displaying checkout time
$TIMEZONE_OFFSET = $selection->get(RealTime::GUI_TIMEZONE_OFFSET) != "" && is_numeric($selection->get(RealTime::GUI_TIMEZONE_OFFSET)) ? (int) $selection->get(RealTime::GUI_TIMEZONE_OFFSET) : 0;
$CLIENT_TIME = $selection->get(RealTime::GUI_CLIENT_TIME);
$tokencostdefault = $selection->get(RealTime::GUI_TOKEN_COST);
$CLIENT_TIME = substr($CLIENT_TIME, 0, 10);
//echo $TIMEZONE_OFFSET . " " . $CLIENT_TIME;  
$odd = false;

$tokencostdefault = $tokencostdefault == null ? SystemSettings::get(SystemSettings::SERVER_NS . "licensemonitor.tokencost.default") : $tokencostdefault;

// Get user sort selections
$userSortBy = $selection->get(RealTime::GUI_USER_SORTBY);
$userSortAsc = $selection->get(RealTime::GUI_USER_SORTASC);

$overlayFlag = SystemSettings::get(SystemSettings::SERVER_NS . "licensemonitor.overlay.mapping.data", 0);

$history_dir = $_SERVER['DOCUMENT_ROOT'] . "/OpeniT/results/quick_history/";

// Chart display
if ($selection->get("presentation_type") == "chart") {


////////////////
////////////////   CHART VIEW
////////////////
	
?>

<div id="chart">
	<div class="itemHeader<?= $CSS_for_IE6; ?>" id="header">
	<div class="availableHeader<?= $CSS_for_IE6; ?>">
	<p><?= tt("dashboard_license_usage_unused") ?></p>
	</div>
	<div class="usedHeader<?= $CSS_for_IE6; ?>">
	<p><?= tt("dashboard_license_usage_inuse") ?></p>
	</div>
	</div>
<?php

// Find our 1% value, based on the max value (We use 50 as 100%, since we have 50% used and 50% free)
$e = 50 / log($MAX);

foreach ($entries as $i => $entry) {

	//encode quotes
	$name = htmlentities($entry->name, ENT_QUOTES);
	//Remove the appended token pool from the feature name
	$displayName = $entry->tokenPool ? substr($name,strlen($entry->tokenPool)) : $name;
	
	// hack to support real sorting with global mappings
	/*
	if ($measurement == 'products' && strstr($name, '## --') && count($realtime->getSelections(RealTime::PRODUCT)) == 0) {
		continue;
	}
	
	if (strstr($name, '## --')) {
		$name = substr($name, strpos($name, '## --')+2);
	}
	*/
	
	// Get data from object
	$usage = $entry->getRealTimeLicenseUsage(true);
	$usageT = $entry->getRealTimeLicenseUsage();
	$total = $entry->getRealTimeTotaltLicenses();
	
	//Check if the user checked the use token cost option
	$tokens = $total;
	$usage = $entry->tokenPool ? ( $tokencostdefault ? $usage * $entry->tokenCost : $usage ) : $usage;
	$total = $entry->tokenPool ? ( $tokencostdefault ? $total : floor($total/$entry->tokenCost)) : $total;
	
	
	// Support 0 in totalt
	if ($total == 0 && $usageT > 0) {
		$total = $usageT;
	}
	
	// Skip item, if we dont have any users in it
	if (isset($showUsers) && count($realtime->getSelections(RealTime::USER)) != 0 && count($entry->getUsers()) == 0) {
		continue;
	}
	
	else if (isset($showUsers) && count($realtime->getSelections(RealTime::USER)) != 0) {
		$showEntry = false;
		foreach($entry->getUsers() as $user) {
			if ($user->isSelected()) {
				$showEntry = true;
				break;
			}
		}
		if (!$showEntry) continue;		
	}	
		
	// Find % of Available (Natural logarithm)
	$available = log($total - $usageT) * $e;

	// Is data going "out-of-screen"
	$availableCorrected = (!is_nan($available) && $available > 50) ? true : false;
	
	
	// Find % of used (Natural logarithm)
	$used = log($usage) * $e;
	$usedT = 0;
		
	// If usage and usage totalt differs, we need to calculate the used for total
	if ($usage != $usageT) {		
		// Find % of used total (Natural logarithm)
		$usedT = log($usageT) * $e;		
	}
	
	// Don't allow any of the values to pass 50%
	if (!is_nan($available) && $available > 50) $available = 50;
	if (!is_nan($used) && $used > 50) 			$used = 50;
	if (!is_nan($usedT) && $usedT > 50) 		$usedT = 50;
	
	// If we have data, don't allow the % to be smaller than 0.3
	if ($used < 0.3 && $usage >= 1) $used = 0.3;
	if ($available < 0.3 && ($total - $usageT) >= 1) $available = 0.3;

	//hack to replace "&apos;" to single quote in IE: str_replace("&apos;", "'",$entry->name)
?>	
<div class="item<?= $CSS_for_IE6; ?><?= $measurement != "" ? " drilldown" : "" ?>"  onclick="<?= $measurement != "" ? "drillDown('" . $measurement . "', '" . $name . "')" : '' ?>" >
	<?php 
	
		// For all entries that is not a product
		if (!$entry instanceof RealTimeProduct) {

			// clean characters of product and feature name for locating csv files for Highcharts
			$prod_name = preg_replace('/[,]/', '-_', $entry->getProductName());
			$prod_name = preg_replace('/[;]/', '_-', $prod_name);
			$prod_name = preg_replace('/[^a-zA-Z0-9-_]/', '__', $prod_name);

			$feat_name = preg_replace('/[,]/', '-_', $entry->name);
			$feat_name = preg_replace('/[;]/', '_-', $feat_name);
			$feat_name = preg_replace('/[^a-zA-Z0-9-_]/', '__', $feat_name);
	?>

		<label value="<?=trim(str_replace("&apos;", "'",$entry->name))?> "<?= (strlen($name)>35) ? 'onmouseover="Scroller.start(this)" onmouseout="Scroller.stop(this)"' : '' ?> ><?= strlen(str_replace("&apos;", "'",$displayName))>40 ? trim(substr(str_replace("&apos;", "'",$displayName), 0, 35))."..." : str_replace("&apos;", "'",$displayName) ?> (<?= $total == 0 ? "N/A" : ($entry->tokenCost ? "pool=" . $entry->tokenPool .", cost=". $entry->tokenCost .", #tokens=".$tokens  : $total) ?>)</label>	
		<div class="available <?= $availableCorrected ? 'corrected' : '' ?>" style="width: <?= $available ?>%">
			<p><?= $entry->tokenPool ? $total : $total - $usageT ?></p>
		</div>
		<?php if (isset($usedT)) { ?> <div class="used total" style="width: <?= $usedT ?>%"></div> <?php } ?>	
		<div class="used" style="width: <?= $used ?>%">
			<p><?= $usage ?></p>
		</div>
	<?php if(file_exists($history_dir . $prod_name . "_-" . $feat_name . ".csv")){ ?>
		<div id="history-link" style="float:right; padding:5px; z-index:1000;">
			<a id="historylink" href="javascript:void(0)" onclick="showHistoryPopup('<?= $entry->getProductName() ?>', '<?= $entry->name ?>');">History</a>
		</div>
	<?php } ?>		
	<?php 
		}
		
		// for product entry, we remove the license usage numbers..
		else {			
	?>
	
		<label value="<?=trim(str_replace("&apos;", "'",$entry->name))?> "<?= (strlen($name)>35) ? 'onmouseover="Scroller.start(this)" onmouseout="Scroller.stop(this)"' : '' ?> ><?= strlen(str_replace("&apos;", "'",$entry->name))>35 ? trim(substr(str_replace("&apos;", "'",$entry->name), 0, 35))."..." : str_replace("&apos;", "'",$entry->name) ?></label>		
		<div class="available <?= $availableCorrected ? 'corrected' : '' ?>" style="width: <?= $available ?>%">
			<div>
			<p><?= "" /*$total - $usageT*/ ?></p>
			</div>
		</div>
		<?php if (isset($usedT)) { ?> <div class="used total" style="width: <?= $usedT ?>%"></div> <?php } ?>	
		<div class="used" style="width: <?= $used ?>%">
			<p><?= $usage ?></p>
		</div>
	
	<?php 
		}
	?>
	<? if($CSS_for_IE6 != '') echo '<div class="licensemonitor-IE"></div>'; ?>
</div>

<?php if (isset($showUsers) && count($entry->getUsers()) != 0) { ?>
<div class="userinfo" id="userInfoList_<?= $name ?>" style="<?= (isset($userblock[$name]) && $userblock[$name]) ? '' : 'display: none;' ?>" >
	<img src="/gfx/loader-bar.gif" border="0"> Please wait ...
</div>
<?php } ?>



<?php
}
?>
</div>


<?php }

////////////////
////////////////   TABLE VIEW
////////////////

else { ?>


<table id="table" class="list license_monitor_table">
	<thead>
		<tr>
			<th>Name</th>
			<th>Total Licenses</th>
			<th><?= tt("dashboard_license_usage_unused") ?></th>
			<th><?= tt("dashboard_license_usage_inuse") ?></th>
		</tr>
	</thead>
	<tbody>
<?php


foreach ($entries as $i => $entry) {
	
	// Skip item, if we dont have any users in it
	if (isset($showUsers) && count($realtime->getSelections(RealTime::USER)) != 0 && count($entry->getUsers()) == 0) {
		continue;
	}
	
	else if (isset($showUsers) && count($realtime->getSelections(RealTime::USER)) != 0) {
		$showEntry = false;
		foreach($entry->getUsers() as $user) {
			if ($user->isSelected()) {
				$showEntry = true;
				break;
			}
		}
		if (!$showEntry) continue;		
	}		
	
	$name = htmlspecialchars($entry->name, ENT_QUOTES);
	//Remove the appended token pool from the feature name
	$displayName = $entry->tokenPool ? substr($name,strlen($entry->tokenPool)) : $name;
	
	$usage = $entry->getRealTimeLicenseUsage(true);
	$usageT = $entry->getRealTimeLicenseUsage();
	
	$total = $entry->getRealTimeTotaltLicenses();
	
	//Check if the user checked the use token cost option
	$tokens = $total;
	$usage = $entry->tokenPool ? ( $tokencostdefault ? $usage * $entry->tokenCost : $usage ) : $usage;
	$total = $entry->tokenPool ? ( $tokencostdefault ? $total : floor($total/$entry->tokenCost)) : $total;

	$odd = $odd == false ? true : false;
?>	
		<tr class="<?= $odd ? 'odd' : 'even' ?>">
			<td class="pfname item<?= $measurement != "" ? " drilldown" : "" ?>" " value="<?=trim(str_replace("&apos;", "'",$entry->name))?> "<?= (strlen($name)>35) ? 'onmouseover="Scroller.start(this)" onmouseout="Scroller.stop(this)"' : '' ?> onclick="<?= $measurement != "" ? "drillDown('" . $measurement . "', '" . $name . "')" : '' ?>"><?= strlen(str_replace("&apos;", "'",$displayName))>35 ? trim(substr(str_replace("&apos;", "'",$displayName), 0, 35))."..." : $entry->tokenCost ? str_replace("&apos;", "'",$displayName) . " (pool=" . $entry->tokenPool .")" : str_replace("&apos;", "'",$displayName) ?></td>
			<td><?= $total == 0 ? "N/A" : ($entry->tokenCost ? "(token-cost=". $entry->tokenCost .", #tokens=".$tokens.")"  : $total) ?></td>
			<td><?= $entry->tokenCost ? $total : $total - $usageT ?></td>
			<td><?= $usage ?></td>
		</tr>

<?php if (isset($showUsers) && count($entry->getUsers()) != 0) { ?>
<tr>
	<td colspan="4" style="margin: 0; padding: 0;">
<div class="userinfo" id="userInfoList_<?= $name ?>" style="<?= (isset($userblock[$name]) && $userblock[$name]) ? '' : 'display: none;' ?>" >
	<img src="/gfx/loader-bar.gif" border="0"> Please wait ...
</div>
	</td>
</tr>
<?php } ?>

<?php
}
?>
	</tbody>
</table>

<?php } ?>

		